unit prot32;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables, Protect, Grids, DBGrids, StdCtrls, ExtCtrls, ComCtrls,
  Buttons, Menus, ShellAPI;

type
  TForm1 = class(TForm)
    Protector1: TProtector;
    tblJobTrans: TTable;
    tblStrCopy: TTable;
    tblBackUp: TTable;
    DataSource1: TDataSource;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Button1: TButton;
    Button3: TButton;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    Button4: TButton;
    SpeedButton1: TSpeedButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Break1: TMenuItem;
    Tablefile1: TMenuItem;
    PrimaryIndex1: TMenuItem;
    SecondaryIndex1: TMenuItem;
    Protection1: TMenuItem;
    On1: TMenuItem;
    Off1: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    N1: TMenuItem;
    Changeindextosecondary1: TMenuItem;
    Changeindextoprimary1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    PopupMenu1: TPopupMenu;
    TableFile2: TMenuItem;
    PrimaryIndex2: TMenuItem;
    SecondaryIndex2: TMenuItem;
    Button5: TButton;
    Button6: TButton;
    PopupMenu2: TPopupMenu;
    ActivatePrimaryIndex1: TMenuItem;
    ActivateSecondaryIndex1: TMenuItem;
    About1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure PrimaryIndex1Click(Sender: TObject);
    procedure Changeindextoprimary1Click(Sender: TObject);
    procedure Changeindextosecondary1Click(Sender: TObject);
    procedure SecondaryIndex1Click(Sender: TObject);
    procedure Tablefile1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public

    { Public declarations }
  end;
var
  Form1: TForm1;
  FPointer: Pointer;
  Names : TstringList;
implementation

uses About;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
 if Button1.Caption = '&Protect' then
   begin
     On1.Enabled:=false;
     Off1.Enabled:=True;
     Button1.Caption := '&UnProtect';
     StatusBar1.Panels.Items[1].Text:= 'Table Protected with the Component';
   end
 else
   begin
     On1.Enabled := true;
     Off1.Enabled := False;
     Button1.Caption := '&Protect';
     StatusBar1.Panels.Items[1].Text:= 'Table Protection is Off';

   end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if Button1.caption ='&UnProtect' then
  begin
    StatusBar1.Panels.Items[1].Text:= 'Opening the table in protected mode...';
    screen.cursor:= crHourglass;
    DBGrid1.datasource:= nil;
    Protector1.ProtectedOpen;
    DBGrid1.datasource:=DataSource1;
    screen.cursor:= crDefault;
    StatusBar1.Panels.Items[1].Text:= 'Table protected with the component';
  end
else
    tblJobTrans.Open;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if tblJobTrans.active then tblJobTrans.close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
DirString,
FileNameStr      : String;

Character,
FileNamePchar    : PChar;

SourceOfStr      : Pofstruct;

IntRes,
Handle           : Integer;

AliasParams      : TstringList;

begin
  AliasParams := TstringList.Create;
  Session.GetAliasParams(tblJobTrans.DatabaseName, AliasParams);
  DirString := Copy(AliasParams.Strings[0],6,60);
  if copy(DirString,length(trim(DirString)),1)<>'\' then
    DirString := DirString+'\';
  AliasParams.free;
  AliasParams:=nil;
  FileNameStr := DirString + tblJobTrans.TableName;
  GetMem(FileNamePchar,length(FileNameStr)+1);
  GetMem(Character,10);
  StrPCopy(Character,'!!!!!!!!!');
  StrPCopy(FileNamePchar,FileNameStr);
  if tblJobTrans.active then tblJobTrans.close;
  Handle := createfile(FileNamePchar,GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 { Handle := OpenFile(FileNamePchar,SourceOfStr^,OF_WRITE);}
 WriteFile(Handle,Character,10,IntRes,nil);
{  _lwrite(Handle,Character,1);}
  _lclose(Handle);
  dispose(Character);
  dispose(FileNamePchar);
  Showmessage('     Table is broken!       ');
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.PrimaryIndex1Click(Sender: TObject);
var
Tabname,
DirString,
FileNameStr      : String;

Character,
FileNamePchar    : PChar;

SourceOfStr      : Pofstruct;

IntRes,
Handle           : Integer;

AliasParams      : TstringList;

begin
  AliasParams := TstringList.Create;
  Session.GetAliasParams(tblJobTrans.DatabaseName, AliasParams);
  DirString := Copy(AliasParams.Strings[0],6,60);
  if copy(DirString,length(trim(DirString)),1)<>'\' then
  DirString := DirString+'\';
  AliasParams.free;
  AliasParams:=nil;
  Tabname:=copy(tblJobTrans.TableName,1,pos('.',tblJobTrans.TableName)-1);
  FileNameStr := DirString + Tabname+'.px';
  GetMem(FileNamePchar,length(FileNameStr)+1);
  GetMem(Character,10);
  StrPCopy(Character,'!!!!!!!!!');
  StrPCopy(FileNamePchar,FileNameStr);
  if tblJobTrans.active then tblJobTrans.close;
  Handle := createfile(FileNamePchar,GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 { Handle := OpenFile(FileNamePchar,SourceOfStr^,OF_WRITE);}
 WriteFile(Handle,Character,10,IntRes,nil);
{  _lwrite(Handle,Character,1);}
  _lclose(Handle);
  dispose(Character);
  dispose(FileNamePchar);
  Showmessage('   Primary Index is broken.   ');

end;

procedure TForm1.Changeindextoprimary1Click(Sender: TObject);
begin
if Button1.caption ='&UnProtect' then
  begin
    screen.cursor:= crHourglass;
    DBGrid1.datasource:= nil;
    Protector1.NewIndexName:='';
    Protector1.ChangeIndex;
    DBGrid1.datasource:=DataSource1;
    screen.cursor:= crDefault;
  end
else
  tblJobTrans.indexname:='';
DBGRID1.refresh;
end;

procedure TForm1.Changeindextosecondary1Click(Sender: TObject);
begin
if Button1.caption ='&UnProtect' then
  begin
    screen.cursor:= crHourglass;
    DBGrid1.datasource:= nil;
    Protector1.NewIndexName:='SecInd1';
    Protector1.ChangeIndex;
    DBGrid1.datasource:=DataSource1;
    screen.cursor:= crDefault;
  end
else
  tblJobTrans.indexname:='SecInd1';
DBGRID1.refresh;
end;

procedure TForm1.SecondaryIndex1Click(Sender: TObject);
var
Tabname,
DirString,
FileNameStr      : String;

Character,
FileNamePchar    : PChar;

SourceOfStr      : Pofstruct;

IntRes,
Handle           : Integer;

AliasParams      : TstringList;
begin
  AliasParams := TstringList.Create;
  Session.GetAliasParams(tblJobTrans.DatabaseName, AliasParams);
  DirString := Copy(AliasParams.Strings[0],6,60);
  if copy(DirString,length(trim(DirString)),1)<>'\' then
  DirString := DirString+'\';
  AliasParams.free;
  AliasParams:=nil;
  Tabname:=copy(tblJobTrans.TableName,1,pos('.',tblJobTrans.TableName)-1);
  FileNameStr := DirString + Tabname+'.XG0';
  GetMem(FileNamePchar,length(FileNameStr)+1);
  GetMem(Character,10);
  StrPCopy(Character,'!!!!!!!!!');
  StrPCopy(FileNamePchar,FileNameStr);
  if tblJobTrans.active then tblJobTrans.close;
  Handle := createfile(FileNamePchar,GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 { Handle := OpenFile(FileNamePchar,SourceOfStr^,OF_WRITE);}
 WriteFile(Handle,Character,10,IntRes,nil);
{  _lwrite(Handle,Character,1);}
  _lclose(Handle);
  dispose(Character);
  dispose(FileNamePchar);
  Showmessage('   Secondary Index is broken.   ');

{}
end;

procedure TForm1.Tablefile1Click(Sender: TObject);
begin
{}
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  with sender as TButton do
    begin
      PopUpMenu1.popup(Form1.Left+Panel1.Left+Left, Form1.top+Panel1.Top+Top+3*Height);
    end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  with sender as TButton do
    begin
      PopUpMenu2.popup(Form1.Left+Panel1.Left+Left, Form1.top+Panel1.Top+Top+3*Height);
    end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
AboutBox.Showmodal;
end;

end.
